package com.gzlh.infrared.factory;



import com.gzlh.infrared.handler.IRedHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class RedFactory {
    @Autowired
    private List<IRedHandler>handlers;

    public IRedHandler handler(int code){
       return handlers.stream().filter(h->h.brandType().getCode()==code)
                .findAny().orElseThrow(()->new IllegalArgumentException("不支持交互"));
    }

}
