package com.gzlh.led.handler.impl;

import com.gzlh.led.brand.LedBrandType;
import com.gzlh.led.client.LedNettyConfig;
import com.gzlh.led.handler.ILedHandler;
import com.gzlh.led.utils.ColorConver;
import com.gzlh.led.utils.YangBandPackage;
import com.gzlh.infrared.brand.RedBrandType;
import com.gzlh.utils.WordHandlerUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * 上海仰邦科技股份有限公司BX-5(M)K/6K（YY）-V4.2 led发送处理器
 */
@Service
@Slf4j
public class LedHandlerYangBandV4d2 implements ILedHandler {

    @Resource
    private LedNettyConfig ledNettyConfig;

    @Override
    public LedBrandType brandType() {
        return LedBrandType.SHANGHAI_YANGBAND_BX;
    }

    @Override
    public void sendMsg(String content) {
        log.info(RedBrandType.SHANGHAI_YANGBAND_BX.getBrand() + "发送消息:{}", content);
        String pack = YangBandPackage.buildPackage(ColorConver.NU_TO_HEX.get(1) + WordHandlerUtils.msgToASCII(content));
        log.info(RedBrandType.SHANGHAI_YANGBAND_BX.getBrand() + "转换后的数据：{}", pack);
        ledNettyConfig.send(pack);
    }

    @Override
    public void handlerAction(String action) {
        log.info("action:{}",action);
    }
}
