package com.gzlh.weighbridge.factory;
import com.gzlh.weighbridge.handler.IWeighbridgeHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class WeighbridgeFactory {
    @Autowired
    private List<IWeighbridgeHandler>handlers;

    public IWeighbridgeHandler handler(int code){
       return handlers.stream().filter(h->h.brandType().getCode()==code)
                .findAny().orElseThrow(()->new IllegalArgumentException("不支持地磅品牌"));
    }

}
